import { ServiceResponse } from "../interfaces/service-response";
export declare type BulkUpdateService<TRecord, TPathParams> = (records: Array<TRecord>, pathParams: TPathParams) => Promise<ServiceResponse<TRecord>>;
export declare type CreateService<TRecord> = (record?: TRecord) => Promise<ServiceResponse<TRecord>>;
export declare type DeleteService = (id: number, pathParams?: any) => Promise<ServiceResponse<Boolean>>;
export declare type GetService<TRecord, TPathParams> = (pathParams: TPathParams) => Promise<ServiceResponse<TRecord>>;
export declare type ListService<TRecord, TQueryParams> = (queryParams?: TQueryParams) => Promise<ServiceResponse<TRecord>>;
export declare type NestedCreateService<TRecord, TPathParams> = (record: TRecord, pathParams: TPathParams) => Promise<ServiceResponse<TRecord>>;
export declare type NestedListService<TRecord, TPathParams, TQueryParams> = (pathParams: TPathParams, queryParams?: TQueryParams) => Promise<ServiceResponse<TRecord>>;
export declare type UpdateService<TRecord, TPathParams> = (record: TRecord, pathParams?: TPathParams) => Promise<ServiceResponse<TRecord>>;
declare const ServiceFactory: {
    bulkUpdate<TRecord extends any, TPathParams extends {
        id: number;
    }>(recordType: new () => TRecord, resourceEndpoint: string): BulkUpdateService<TRecord, TPathParams>;
    create<TRecord_1 extends any>(recordType: new () => TRecord_1, baseEndpoint: string): CreateService<TRecord_1>;
    delete(resourceEndpoint: string): DeleteService;
    get<TRecord_2, TPathParams_1>(recordType: new () => TRecord_2, resourceEndpoint: string): GetService<TRecord_2, TPathParams_1>;
    list<TRecord_3, TQueryParams>(recordType: new () => TRecord_3, baseEndpoint: string): ListService<TRecord_3, TQueryParams>;
    nestedCreate<TRecord_4 extends any, TPathParams_2>(recordType: new () => TRecord_4, baseEndpoint: string): NestedCreateService<TRecord_4, TPathParams_2>;
    nestedList<TRecord_5, TPathParams_3, TQueryParams_1>(recordType: new () => TRecord_5, baseEndpoint: string): NestedListService<TRecord_5, TPathParams_3, TQueryParams_1>;
    update<TRecord_6 extends any, TPathParams_4 extends any>(recordType: new () => TRecord_6, resourceEndpoint: string): UpdateService<TRecord_6, TPathParams_4>;
};
export { ServiceFactory };
